﻿using System;

using Newtonsoft.Json;

using ProtoBuf;

using Vintagestory.API.MathTools;

namespace Automap
{
	[JsonConverter(typeof(BlockPosConverter))]
	[ProtoContract]
	public class BlockPosJson : BlockPos
	{

		public BlockPosJson( )
		{
			
		}

		public BlockPosJson(BlockPos orig) : base(x: orig.X, y: orig.Y, z: orig.Z)
		{
		}
	}

	/// <summary>
	/// How JSON object conversion should be done for special formatting
	/// </summary>
	public class BlockPosConverter : JsonConverter 
	{
		public override bool CanConvert(Type objectType)
		{
		return objectType == typeof(BlockPosJson);
		}

		public override bool CanRead {
			get
			{
			return false;
			}
		}

		public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
		{
		throw new NotImplementedException( );
		}

		public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
		{
		if (value != null) {
		BlockPosJson bpj = value as BlockPosJson;

		writer.WriteStartArray( );
		writer.WriteValue(bpj.X);
		writer.WriteValue(bpj.Y);
		writer.WriteValue(bpj.Z);
		writer.WriteEndArray( );
		}
		else writer.WriteNull( );

		}

	}
}

