let vf = null;
let chunkScript = document.createElement('script');
chunkScript.type = 'text/javascript';
chunkScript.src = 'Metadata.js';
document.getElementsByTagName('body')[0].append(chunkScript);
chunkScript.addEventListener('load', () => {
	vf = new ViewFrame();

	// resize, delay re-render to reduce lag.
	var resizeId;
	window.addEventListener('resize', () => {
		clearTimeout(resizeId);
		resizeId = setTimeout(() => {
			vf.render();
		}, 500);
	});

	// reload the chunk list every six seconds
	ViewFrame.devBlockReload = true; // disable via command line
	setInterval(() => {
		if (ViewFrame.devBlockReload) return;
		vf.reloadChunkList(true);
	}, 6000);

	// #### CONTROLS ####
	// panning
	var panId;
	vf.map.canvas.addEventListener('mousedown', event => {
		clearTimeout(panId);
		vf.moveScreenWiseCenter([event.pageX, event.pageY]);

		panId = setTimeout(() => {
			vf.render();
		}, 100);
	});

	// scroll/zoom
	vf.map.canvas.addEventListener('wheel', event => {
		if (event.deltaY > 0) vf.zoomIndex++;
		else if (event.deltaY < 0) vf.zoomIndex--;
		vf.render();
	});

	// go to

	// ### data things ###
	// hovering
	var lastX = 0;
	var lastY = 0;
	vf.map.canvas.addEventListener('mousemove', event => {
		// only count if the mouse moved more than a chunk
		const screenCoord = [event.clientX, event.clientY];
		let [x, y] = vf.screenWiseToChunks(screenCoord);
		x = Math.floor(x);
		y = Math.floor(y);
		if (x == lastX && y == lastY) return;
		lastX = x;
		lastY = y;
		vf.updateInfobox(x + '_' + y);
	});
	
	var hasPoIsMarked = false;
	vf.map.canvas.addEventListener('mousemove', event => {
		
		const blockCoord = vf.screenWiseToBlocks([event.clientX, event.clientY]);
		let guesses = guessNear(blockCoord, ViewFrame.chunks.pointsOfInterest, vf.chunkSize);
		if (guesses.length > 0) {
			vf.renderPoIs();
			vf.renderOnePoI('a', guesses[0][0].split('_', 2), 'lightgreen');
			vf.updatePoIbox(guesses[0][0]);
			hasPoIsMarked = true;
		} else if (hasPoIsMarked) {
			hasPoIsMarked = false;
			vf.renderPoIs();
		}
	});

}, {
	once: true
});